' ##############################################################
' Projekt:	TIGER
' ##############################################################
' Modul:	FLASH.INC / Funktionen zum speichern/lesen von FLASH-Zellen
' ##############################################################
' Version:	1.00 vom 28.02.2003
' ##############################################################
' Copyright:
'	Dieses Modul ist ein #include fr den Tiger-Basic Programmierer
'	und wird pro Lizenznehmer lizensiert. Der Lizenznehmer darf dieses Include
'	in beliebig vielen Programmen verwenden und den kompilierten Tiger-Code
'	weitergeben (in .TGU-Dateien) und in eigenen Projekten in beliebig
'	viele Tiger-Module einprogrammieren.
'	Die Weitergabe des Source-Codes ist ohne die schriftliche Zustimmung
'	des Autors nicht zulssig.
'
'	Autor:
'	Martin Graeber
'	Vogelweher Str. 32
'	67661 Kaiserslautern
'	Tel. +49 (0) 631 350 6059
'	mg@grco.de
' ##############################################################

' A C H T U N G !!!!
' Der Code ist NICHT dafr ausgelegt, aus mehreren Tasks gerufen zu werden !!!

' A C H T U N G !!!!
' Bei Erweiterungen ist auf hchste Sorgfalt zu achten !
' Z.B. ist beim Schreiben eine gewisse "Sicherheit" einzubauen, so dass z.B. erst die neuen Werte
' geschrieben werden und dann die alten ungltig gemacht werden.

' A C H T U N G !!!!
' Routine fl_init() ist anzupassen auf die Tiger- und Projekt-spezifischen Gegebenheiten
' Kehrt fl_init mit einem Return-Code <> 0 zurck, so ist das Modul nicht
' betriebsbereit !!!! Siehe Beispiel-Programm
' fl_init() ist einmalig vom Hauptprogramm (TASK MAIN) aufzurufen

' A C H T U N G !!!!
' Die Reorganisationsroutinen arbeiten mit dem Befehl erase_flash. Daher bleibt der
' Tiger ggf. kurz stehen, wenn diese Routine aufgerufen wird.

' A C H T U N G !!!!
' Wer Speicherplatz sparen will, kann auf die Verarbeitung der String-Flash
' verzichten und alle Routinen und Init, sowie globale Defines und Variablen
' die mit fl_s_... beginnen entfernen ! Somit wird Speicherblock 2 und 3 Frei
' Der gesamte Speicherverbrauch reduziert sich so auf 128 kBytes Flash und
' je nach fl_max_var Einstellung RAM

' A C H T U N G !!!!
' Die maximale, in der Dateiverarbeitung verarbeitbarer, Stringlnge ist systembedingt
' begrenzt. Die Lnge ist in dem define fl_s_maxstring und fl_s_maxstring3 (+3)
' anzugeben. Man verwende den Speicherplatz sparsam, Die Werte sollten
' mglichst klein, jedoch mindestens 256 sein. Im Standard ist "300" eingestellt.
' Die maximale Stringlnge wird fr die Reorganisation bentigt und wird vom
' Stack verbraucht beim Reorganisieren. Eine maximale Stringlnge von 10000 wrde
' also vom Stack 10000 Bytes beim Reorganisieren verbrauchen ! Der eigentliche
' Speicherverbrauch im Flash ist immer nur so gro, wie der String lang ist.
' TIP: Darauf achten, da die bergebenen String-Variablen immer mit der
' richtigen Lnge gesetzt sind. Gegebenenfalls vorher Funktion SET_LEN$ verwenden.

' A C H T U N G !!!!
' Werten Sie unbedingt die Return-Variablen korrekt aus !
' Die Return-Variablen geben Aufschluss ber das Ergebnis der Funktion.
' Die mglichen Return-Werte sind in den Funktions-Headers selbst beschrieben.
' Im allgemeinen bedeutet ein Return-Wert "0", da die Funktion erfolgreich
' durchgefhrt wurde. Alle anderen Werte zeigen einen Fehler oder z.B.
' "Ende der Datei" an.
' ##############################################################
' Grundlegendes:
'	Dieses Modul ermglicht das Schreiben und Lesen von Variablen und Dateien
'	fr den Basic Tiger von Wilke. Hierzu wird der Flash-Speicher verwendet.

'	Geschriebene Variablenwerte und Dateien bleiben nach dem Ausschalten
'	der Betriebsspannung erhalten. Ein Lesen der Variablen ist nach dem Neustart
'	und Initialisierung mglich.

'	Auf Grund der Eigenart des Flash-Speichers, dass nmlich einzelne Flash-
'	Zellen, die bereits geschrieben wurden, nicht mehr gendert werden knnen,
'	wurde dieses Modul geschaffen, welches sich um die Flash-Speicherverwaltung
'	selbststndig kmmert. Das Modul arbeitet so, da nicht mehr verwendete
'	Zellen als ungltig markiert werden. Somit entsteht im Lauf der Zeit durch
'	ablegen der Variablen "Lcher" an den Stellen vo diese Variable
'	bzw. Datei vor der Schreiboperation gestanden ist. Diese Lcher werden
'	ber die Reorganisationsfunktionen wieder bereinigt. (s.u.) Der Anwender braucht
'	sich nicht um das Beachten der Lcher zu kmmern. Hierzu wurde das Modul
'	geschaffen

'	Ein direktes Schreiben und Lesen des Flash-Speichers durch den Anwender ist
'	nicht mehr ntig (wenn auch mglich). Es wird daher nicht empfohlen,
'	die Funktionen poke_flash, pokem_flash, peek_flash und erase_flash in den
'	von diesem Modul verwendeten Speicherbereichen zu verwenden.

'	Dieses Modul verwendet grundstzlich die ersten 4 ganzen Flash-Pages
'	(Beim Tiny-Tiger-economy sind diese je 64 kBytes gross). Soll dies gendert werden,
'	so ist der Code und die #defines in diesem Modul anzupassen. Bei Fragen
'	hierzu wenden Sie sich gerne an den Autor

'	Die Pages 0 und 1 werden fr die Variablen verwendet. Es stehen maximal
'	eine Page fr Nutzdaten zur Verfgung. Die jeweils andere wird zum Reorganisieren
'	fr Variablen und Dateien freigehalten.
'	Die Pages 2 und 3 werden fr die Dateien verwendet und knnen komplett
'	geschrieben werden. Bei 64 kBytes groen Flash-Seiten knnen somit bis
'	zu 64kBytes Variablen und 128 kBytes Dateien abgelegt werden. Pro
' 	Variable gehen 5 und pro Datensatz in Dateien 3 Bytes
'	Kontrollinformation im Flash "verloren". Die maximale Verwendung sollte aber
'	mit den #defines fl_datalength, fl_maximumusage und fl_s_datalength
'	so begrenzt werden, da immer ausreichend Raum hinter dem genutzten Bereich
'	vorhanden ist, so da bis zum nchsten fl_do_reorg oder fl_s_reorg
'	weitergearbeitet werden kann, ohne das der Speicher voll luft.

'	Der Programmierer mu selbst dafr Sorge tragen, die Funktionen
'	fl_do_reorg und fl_s_reorg aufzurufen. Diese Routinen reorganisieren den
'	Flash speicher, wenn notwendig. Die Funktion fl_status gibt auskunft ber
'	den fllstand der Speicherbereiche

'	Die Variablen werden direkt aus dem Programm mit den Funktionen fl_sav...
'	geschrieben und mit den Funktionen fl_... gelesen.
'	Die Variablen indizes sind als Word-Wert zu bergeben. Der Inhalt wird
'	direkt als Variable bergeben

'	Die Dateien sind sequentiell orientiert und lassen das sequentielle schreiben
'	und lesen von Strings zu. Eine Datei hat eine ID (Byte) und besteht aus
'	0 bis eine maximale Zahl von Datenstzen.
'
'	Beim Schreiben von Variablen und Dateien wird auf den freien Speicher geprft
'	und ggfs. der Schreibvorgang abgewiesen. Bei Variablen gibt es keinen
'	return-Wert, der diesen Zustand anzeigt. Bei Dateien wird in den
'	schreib-routinen im Returncode der volle Speicher angezeigt.

'	ACHTUNG! Bei einem unkontrollierten Stromausfall whrend einer
'	Schreiboperation oder der Reorganisation kann dieses Modul Inkonsistenzen
'	im Flash erzeugen, die zur Fehlfunktion fhren. Ein Bereinigen ist
'	nur durch lschen der Flash-Seiten (erase_flash fr Block 0-3) und
'	anschliessendem fl_init mglich. Alle Werte gehen dann verloren.

' ##############################################################
' erforderliche #defines im Hauptprogramm:

' 1. ########################
' #define fl_maxvar xxx
' setze xxx auf den Wert, der den hchsten Index der Flash-Variablen entspricht
' Minimalwert: 1
' Maximalwert: je nach Speicherausbau.

' ACHTUNG !!!
' Pro Index wird ein Speicherverbrauch im RAM von 4 Bytes fllig. Eine sinnvolle
' Einstellung ist also z.B. 100, wenn man ca. 100 Variablen braucht

' ACHTUNG !!!
' Werden Variablen-Indizes verwendet, die ausserhalb des Bereichs liegen, kommt
' es zu undefinierten Fehlern bzw. Laufzeitfehlern !!!

' TIP:
' Verwenden Sie globale #defines im Hauptprogramm, um Variablen global fr das
' gesamte Projekt zu definieren. Siehe Beispielprogramm

' TIP:
' Verwenden Sie strings, um grere Arrays von Zahlen abzuspeichern. Entsprechende
' Beispiele finden Sie im Tiger-Handbuch. Die Funktionen sind u.a. NTOS$, RTOS$, RFROMS, STOS$	baut die Bytes einer numerischen Variablen vom Typ BYTE, WORD oder LONG in einen String ein.

' 2. ########################
' #define dbg_dev xxx
' Definieren eines Ausgabegertes fr die Debug-Meldungen des Moduls.
' Verwenden Sie z.B. den Wert eines geffneten LCD-Treibers oder hnliches

' 3. ########################
' Variable fl_debug n
' Setze n auf 1, wenn Ausgaben auf dbg_dev gemacht werden sollen
' Setze n auf 0, wenn Flash keine Debug-Ausgaben machen soll

' 4. ########################
' #define fl_s_max_handle n
' n = maximale Anzahl der Dateien fr sequentielle Verarbeitung
' n Minimal 1, maximal 160
' ACHTUNG! Pro Handle werden 9 Bytes RAM verbraucht !

' ##############################################################
' Bereitgestellte Funktionen:

' fl_init(var byte fl_init_rc)			Initialisieren Modul FLASH
' fl_byte(word idx; var byte b)
' fl_word(word idx; var word w)
' fl_long(word idx; var long l)
' fl_real(word idx; var real r)
' fl_string(word idx; var string s$)		Lesen von Byte, Word, Long, Real, String
' fl_long_set(word idx; var long l)		Lesen von Long, nur wenn vorhanden

' fl_sav_byte(word idx; byte b)
' fl_sav_word(word idx; word w)
' fl_sav_long(word idx; long l)
' fl_sav_real(word idx; real r)
' fl_sav_string(word idx; string s$)		Schreiben von Byte, Word, Long, Real, String

' fl_delete(word idx)				Lschen einer Variablen aus dem Speicher

' fl_do_reorg()					Reorganisieren des Speichers wenn fl_reorg = 1
' fl_dump(long start, length; byte level)	Dump eines Flash-Bereichs auf DBG-Out

' fl_status(var Long var_used; var long var_effective; var long s_used; var long s_effective)
' Ermitteln des verbrauchten Flash-Speichers

' Ab hier Routinen zur sequenziellen dateiorientierten String-Verarbeitung:

' fl_s_open_read(byte fileid)
' 	- Zum Lesen: ffnen der "Datei", Setzt File-Pointer auf 0
' fl_s_open_write(byte fileid)
'	- fl_s_open_write: zum Schreiben: ffnen der "Datei", setzt File-Pointer auf 0
'	- ggfs. lschen einer bestehenden Datei
' fl_s_close(byte fileid)
' 	- fl_s_close: zum schliessen: close der Datei, beendet file-operation, macht Datei gltig
' fl_s_write(byte fileid; string s$; var byte retcode)
'	- fl_s_write: Datenstze scheiben.
' fl_s_read(byte fileid; var string s$; var byte retcode)
'	- fl_s_read: Datenstze lesen.
' fl_s_open_append(byte fileid)
'	- fl_s_open_append: zum Schreiben ffnen der "Datei", setzt File-Pointer auf ende
' fl_s_write_append(byte fileid; string s$; var byte retcode)
'	- fl_s_write_append: Datenstze scheiben. Nur fr Dateien, die mit _append geffnet sind
' fl_s_reorg()
'	- fl_s_reorg: Prfen der im Speicher befindlichen Datenstze
'	- ggfs. Reorganisation des Speichers
'	- Luft nur, wenn *ALLE* Dateien geschlossen sind !!!!
' fl_s_copyfile(Byte Fromfile, Tofile; Var Byte copyfile_retcode)
'	- Kopieren einer Datei in eine andere Datei


' ##############################################################
' Konstanten, ggfs. an Typ des Tigers anpassen

' die folgenden Konstanten sind auf einen Tiny-Tiger "E" optimiert.
' Die Blockgre ist hier 65 KBytes, es werden die Blcke 0,1,2,3 "verbraucht"
' Also alle Flash-Adressen von (0) bis (262143)
' Ab Flash-Adresse
' einige Konstanten, die man so braucht...
#define		fl_block_1	0	' Adresse des Kontrollbytes Block 1
#define		fl_block_2	65536	' Adresse des Kontrollbytes Block 2
#define		fl_blocklength	65536	' Lnge der Flash-Sektoren. Fr Reorg bentigt...
#define		fl_datalength	11000	' Lnge der Daten bis zur Reorganisation (Fllstand -> reorg)

#define		fl_maximum_usage 40000	' Nur bis zu diesem Fllstand schreiben

' ACHTUNG: fl_datalength ist reorg, bei dem das Flag gesetzt wird
' wird jedoch fl_maximum_usage berschritten, wird gar nicht mehr geschrieben !
' Wurde zur Sicherheit in 2.01 eingefhrt.

' Fr sequentielle Dateien bentigt:

#define		fl_s_block_1	131072	' Beginn des Speichers fr sequentielle Daten (Flash sektor 2)
#define		fl_s_block_2	196608	' Beginn des Flashs fr sequentielle Daten (Flash sektor 3)
#define		fl_s_datalength	40000	' Lnge der Daten bis zur Reorganisation (Fllstand -> reorg)

    ' nur fr 2. Block im fl_s gltig !
    ' ACHTUNG: Wert sollte klein genug sein, so dass nicht der
    ' Flash berluft beim Schreiben, jedoch gross genug, alle files aufzunehmen.
    ' Beim Schreiben wird der Fllstand nmlich nicht geprft, sondern zyklisch bei fl_s_reorg()
    ' Variable fl_s_datalength betrifft nur den 2. Block im fl_s - Fllstand

' ##############################################################
' in diesem Array legen wir die aktuellen Adressen der Variablen ab
array fl_adresses(fl_maxvar) of long

' Typdeklarationen fr flash-Variablen
#define		fl_type_byte	1
#define		fl_type_word	2
#define		fl_type_long	3
#define		fl_type_real	4
#define		fl_type_string	5
#define		fl_type_unknown	255

' ##############################################################
' Globale defines fr fl_s (Flash-Sequential):

'ACHTUNG: fl_s_maxstring mindestens 256 !!! WARUM: Siehe Routine fl_s_reorg()
' Hauptprogramm fl_s_maxstring		300		' maximale Lnge eines Strings fr fl_s
' Hauptprogramm	fl_s_maxstring3		303		' Plus 3 fr pokem_flash mit Index + len

' Status fr fl_s_search_next

#define	fl_s_s_ok	0			' Status fr nchster Satz gefunden	
#define	fl_s_s_notfound	1			' Status fr "Nix weiter gefunden"

#define	fl_s_next_block	0aaH			' Handle fr nchsten Block.
						' NICHT fr Dateien verwenden !
' ##############################################################
' Der Flash-Speicher ist folgendermassen Organisiert:

' Sektoren 0 - 3 a jeweils 65 KBytes:
'	Daten, die ber dieses Modul geschrieben / gelesen werden

' ab Sektor 4 (Adr 262144 dez.)
'	reserviert fr allgemeine Benutzung, kein Zugriff aus diesem Modul
' hier werden allgemeine Daten abgelegt, z.B. knnen hier die Benutzer mit
' datalabel zugreifen (Ab Adresse 262144 freie Benutzung)

' ##############################################################

' Der Flash fr Variablen in diesem Modul ist folgendermassen aufgeteilt:
'

' Sektorbereich 0 u. 1	- Gleich gross (je 1 Sektor mit 65536 Bytes)
'			- enthalten die Flash-Variablen, gltig ist jedoch nur ein Bereich !
'			- Das erste Byte eines Bereichs gibt die Gltigkeit an.
'			  -> 1=Aktiver Bereich, 0=ungltiger Bereich, FFh = gelscht

' Jeder Datenwert besteht aus 4 Eintrgen
'	- WORD Index-Nummer: 0 = Eintrag gelscht oder Nummer der Variable. FFFFh = Ende der Tabelle !
'	- WORD Grsse des Feld/Variableninhalts in Bytes (nur nachfolgende eigentliche Daten)
'	- Byte : Typ der Variablen (fl_type...)
'	- Inhalt fr Variable: Lnge abhngig von dem Typ der Variable

' Hier wird definiert wieviele Control-Bytes pro Datensatz da sind (Index, Grsse, Typ)
' Bitte nicht verndern !
#define	fl_ctrl_len	5

' Reorganisation:
' 	- Beim Schreiben von Variablen wird ggfs. ein Flag-Gesetzt (Globale
'		Variable fl_reorg wird auf 1 gesetzt)
'	- wird durchgefhrt, wenn Platz im Sektor zum Einspeichern nicht mehr ausreicht
'	- dies ist abhnging vom Fllstand, maximal fl_datalength bytes werden in
'	  1 Sektor abgelegt
'	- Der Programmierer sollte regelmig fl_do_reorg aufrufen, um diese
'		Variable abzufragen und ggfs. einen Reorg auszulsen.
' ACHTUNG:
' laut Dokumentation bleibt der Tiger so lange stehen, bis der Lschvorgang erfolgt ist
' dieses Verhalten ist beim Lschen des Flash zu bercksichtigen...
' Tests mit dem Tiny-Tiger "E" haben ergeben, dass das jedoch unter 0,5 Sek. dauert !
' es dauert lnger, die eigentlichen Daten beim Reorg zu kopieren
' TIP: Alle IO-Vorgnge anhalten bzw. fertiglaufenlassen,
'      bevor fl_do_reorg() aufgerufen wird

' Vorgehensweise beim fl_do_reorg():
' 	- zuerst wird neuer Sektor gelscht
'       - Alle Variablen werden dann in den zweiten Sektor zwischengespeichert und dabei reorganisiert
'	- dann wird im "Steuerbyte" (Byte 0) eine 1 eingeschrieben
'	- dann wird der alte Sektor ungltig gemacht, in dem eine "0" in das 1. Byte geschrieben wird
'	- die eigentlichen Daten im alten Sektor bleiben erhalten bis zum nchsten Reorg
'         oder fl_s_reorg()
' ##############################################################
' Globale Vars:

string fl_hexstr$(16)

' ##############################################################
' Globale defines:

#define		fl_not_used		0aa55h

' Globale Vars:
byte	sys_ok			' 0 = System ok, andere Werte enthalten den Fehler
long	block_base		' Basis des Sektors (steht entweder auf fl_block_1 oder fl_block_2)
long	fl_first_free		' Erstes freies Byte im Flash-Adressbereich...

byte	fl_reorg		' 1=Reorg erforderlich, 0=kein Reorg erforderlich

'---------------------------------------------------------------------
' Subroutine fl_init initialisiert die FLASH-Verarbeitung (Variablen und Strings)
'---------------------------------------------------------------------
SUB fl_init(var byte fl_init_rc)

  word w
  byte wert1, wert2
  string w1$, w2$
  long var_used, var_effective, s_used, s_effective
  long fl_adr
  word laenge
  byte fl_type

  fl_reorg = 0
  fl_init_rc = 0

' Suchen, wo ein korrekter Datenbereich ist.

       					' Zuerst block 1 versuchen
  peek_flash fl_block_1, wert1, 1

  if wert1 = 1 then			' Block 1 wurde gefunden !!!
    block_base = fl_block_1
    call fl_last(fl_first_free)		' Berechne erstes freies Datenbyte im Block
  else
    					' Block 1 ist gelscht (?). Es wird jetzt Block 2 Versucht...
    peek_flash fl_block_2, wert2, 1
    if wert2 = 1 then			' Hurra ! Block 2 ist gltig !
      block_base = fl_block_2
      call fl_last(fl_first_free)	' Berechne erstes freies Datenbyte im Block
    else				' Keine gltige Block-Kennung gefunden...
    					' Ersten Bereich lschen und aktiv kennzeichnen
      w1$ = str$(wert1)
      w2$ = str$(wert2)
      if fl_debug = 1 then
        print #dbg_dev, ticks(), "FL_BAD_BLOCK: ", wert1, wert2
      endif

      erase_flash fl_block_1, fl_blocklength
      block_base = fl_block_1
      poke_flash fl_block_1, 1, 0
      call fl_last(fl_first_free)		' Berechne erstes freies Datenbyte im Block
    endif
  endif

  ' Das wars ! In der globalen Variablen block_base ist jetzt immer die Basisadresse des Sektors
  ' In der Variablen fl_first_free immer das erste Freie Byte im flash (Adresse)

  ' Jetzt noch initialisieren des Arrays "fl_adresses". Diese Array nimmt die
  ' Anfangsadressen der Datenstrukturen fr jede Variable auf.
  ' 0 bedeutet: nichts gespeichert

  if fl_debug = 1 then
    print #dbg_dev, "fl_init: Find vars"
  endif

  for w = 1 to fl_maxvar - 1
    fl_adresses(w) = 0		' Initalisiere Adressen-Array

    call fl_find_adr_std(w, fl_adr, laenge, fl_type)
    if fl_type <> fl_type_unknown then
      fl_adresses(w) = fl_adr - fl_ctrl_len	' Adresse zuweisen, wenn gefunden

' only for development:
'  if fl_debug = 1 then
'    print #dbg_dev, "fl_init: Var "; w; " Adr "; fl_adr; " Type "; fl_type
'  endif

    endif
  next

  call fl_s_init()		' Jetzt noch Sequentielle Verarbeitung initialisieren (Flash-S)

  call fl_status(var_used, var_effective, s_used, s_effective)

'  flash_running = 1			' Setze Flag fr Debug-Routine

  if fl_debug = 1 then
    print #dbg_dev, "fl_status: "; var_used; " / "; var_effective; &
		        " / "; s_used; " / "; s_effective
  endif

  fl_hexstr$ = "0123456789ABCDEF"		' Fr Dump-Routine


end ' of sub fl_init()

' ##############################################################
' fl_last: erstes freies Flash-Wort auffinden...

sub fl_last(var long first_free)		' Berechne erstes freies Datenbyte im Block

  long adr
  word l
  byte flt

'########################???????????#####stack check debug start#######
' call check_stack(2)
'########################???????????#####stack check debug end#######


  call fl_find_adr_std(fl_not_used, adr, l, flt) ' Benutze einen ungenutzten wert zum ermitteln des Endes

  first_free = adr				' Adresse zuweisen... erste freie Position

' only for development
'  if fl_debug = 1 then
    'print #dbg_dev, "FL_LAST returns "; first_free
'  endif

end


' ##############################################################
' fl_find_adr_std
' Auffinden einer Variablen im Flash, Standard, loop
' als Laenge wird 0 zurckgegeben, wenn Wert nicht gefunden wurde
' Lnge ist ansonsten die Datenlnge
' Wenn Laenge <> 0 ist, dann steht die ADR direkt auf Datenanfang
' Wenn Laenge = 0  (ungltig), dann steht ADR direkt auf dem 1. freien Speicherplatz im Flash
' Diese Routine durchsucht den speicherbereich in einer Schleife, das kann dauern
' fr das schnelle auffinden von Variablen ist die Routine fl_find_adr_fast zu verwenden

sub fl_find_adr_std(word idx ; var long adr; var word laenge; var byte fl_type)

  word fl_idx				' Inhalt Index-Wert

'########################???????????#####stack check debug start#######
' call check_stack(3)
'########################???????????#####stack check debug end#######

  adr = block_base + 1			' Wir beginnen an der Basis

find_loop: ' **************************************** SCHLEIFE ***********


  peek_flash adr, fl_idx, 2		' Lese den Index-Wert
  peek_flash adr + 2, laenge, 2		' Lese Lnge der Variable

'print #dbg_dev, "Searching: ", fl_idx, " / ", idx, " on adr ", adr, "LEN=", laenge

  if fl_idx = 0FFFFh then		' Ende der Tabelle
    laenge = 0
    fl_type = fl_type_unknown
    return
  endif

  if fl_idx <> idx then			' Immer noch nicht gefunden, schalte weiter...
    adr = adr + fl_ctrl_len + laenge	' Datenlnge + 4 fr Control-Daten
    goto find_loop
  endif

  peek_flash adr + 4, fl_type, 1	' Lese Variablen-Typ

					' Hier wurde die Variable gefunden...
  adr = adr + fl_ctrl_len		' Adresse auf Daten stellen, Laenge ist bereits korrekt
  return

end ' of sub fl_find_adr_std

' ##############################################################
' fl_find_adr_fast
' Auffinden einer Variablen im Flash, Schnell
' als Laenge wird 0 zurckgegeben, wenn Wert nicht gefunden wurde
' Lnge ist ansonsten die Datenlnge
' Wenn Laenge <> 0 ist, dann steht die ADR direkt auf Datenanfang
' Wenn Laenge = 0  (ungltig), dann steht ADR direkt auf dem 1. freien Speicherplatz im Flash
' Diese Routine durchsucht den speicherbereich in einer Schleife, das kann dauern
' fr das schnelle auffinden von Variablen ist die Routine fl_find_adr_fast zu verwenden

sub fl_find_adr_fast(word idx ; var long adr; var word laenge; var byte fl_type)

  if fl_adresses(idx) = 0 then		' Variable nicht vorhanden
    laenge = 0
    fl_type = fl_type_unknown
    adr = fl_first_free			' fr Schreibroutinen direkt 1 freien Platz angeben

'print #dbg_dev, "fl_find_adr_fast (1) returns "; idx, fl_type, adr, laenge

    return
  endif

  adr = fl_adresses(idx)		' Adresse aus Array lesen

  peek_flash adr + 2, laenge, 2		' Lese Lnge der Variable
  peek_flash adr + 4, fl_type, 1	' Lese Variablen-Typ

					' Hier wurde die Variable gefunden...
  adr = adr + fl_ctrl_len		' Adresse auf Daten stellen, Laenge ist bereits korrekt

'print #dbg_dev, "fl_find_adr_fast (2) returns "; idx, fl_type, adr, laenge

end ' of sub_fl_find_adr_fast

' ##############################################################
' fl_byte
' Liefern eines Bytes aus Flash
' Liefert "0", wenn Variable nicht gefunden wurde

sub fl_byte(word idx; var byte b)

  long adr
  word laenge
  byte fl_type

  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  if laenge = 0 then
    b = 0
  else
    peek_flash adr, b, 1
  endif
end

' ##############################################################
' fl_word
' Liefern eines Words aus Flash
' Liefert "0", wenn Variable nicht gefunden wurde

sub fl_word(word idx; var word w)

  long adr
  word laenge
  byte fl_type

  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  if laenge = 0 then
    w = 0
  else
    peek_flash adr, w, 2
  endif
end

' ##############################################################
' fl_long
' Liefern eines Longs aus Flash
' Liefert "0", wenn Variable nicht gefunden wurde

sub fl_long(word idx; var long l)

  long adr
  word laenge
  byte fl_type

  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  if laenge = 0 then
    l = 0
  else
    peek_flash adr, l, 4
  endif
end

' ##############################################################
' fl_long_set
' Liefern eines Longs aus Flash.
' Im Gegensatz zu fl_long wird die Variable nur berschrieben, wenn sie auch
' wirklich im Flash abgespeicehrt war !

sub fl_long_set(word idx; var long l)

  long adr
  word laenge
  byte fl_type

  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  if laenge > 0 then		' Nur wenn wirklich Daten da sind !!!
    peek_flash adr, l, 4
  endif
end

' ##############################################################
' fl_real
' Liefern eines Reals aus Flash
' Liefert "0", wenn Variable nicht gefunden wurde

sub fl_real(word idx; var real r)

  long adr
  word laenge
  byte fl_type

  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  if laenge = 0 then
    r = 0
  else
    peek_flash adr, r, 8
  endif

end

' ##############################################################
' fl_string
' Liefern eines strings aus Flash
' Liefert "" (leerstring), wenn Variable nicht gefunden wurde

sub fl_string(word idx; var string s$)

  long adr
  word laenge
  byte fl_type

  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  if laenge = 0 then
    s$ = ""
  else
    peek_flash adr, s$, laenge
    set_len$(s$, laenge)		' Lnge zwangsweise setzen
  endif

end

' ##############################################################
' fl_sav_byte(idx, b)
' Schreiben eines Bytes in den Flash-Speicher

sub fl_sav_byte(word idx; byte b)

  word laenge
  long adr
  byte fl_type

  if (fl_first_free - block_base) > fl_datalength then	' Prfe Speicher voll
    fl_reorg = 1		' Reorg vormerken
  endif

  if (fl_first_free - block_base) > fl_maximum_usage then	' Speicher voll !
    return
  endif

  ' Variable suchen...
  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  fl_adresses(idx) = fl_first_free

  poke_flash fl_first_free, 	idx, 	0
  poke_flash fl_first_free + 1,	idx,	1
  poke_flash fl_first_free + 2,	1,	0
  poke_flash fl_first_free + 3,	0,	0
  poke_flash fl_first_free + 4, fl_type_byte, 0
  poke_flash fl_first_free + 5,	b,	0
  fl_first_free = fl_first_free + fl_ctrl_len + 1

  if fl_type <> fl_type_unknown then		' Variable war vorhanden
    poke_flash adr - 5, 0, 0			' deaktivieren alter Eintrag...
    poke_flash adr - 4, 0, 0			' Index auf 0
  endif

end ' of fl_sav_byte

' ##############################################################
' fl_sav_word(idx, w)
' Schreiben eines Words in den Flash-Speicher

sub fl_sav_word(word idx; word w)

  word laenge
  long adr
  byte fl_type

  if (fl_first_free - block_base) > fl_datalength then	' Prfe Speicher voll
    fl_reorg = 1			' Reorg vormerken
  endif

  if (fl_first_free - block_base) > fl_maximum_usage then	' Speicher voll !
    return
  endif

  ' Variable suchen...
  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  fl_adresses(idx) = fl_first_free

  poke_flash fl_first_free, 		idx, 	0
  poke_flash fl_first_free + 1,	idx,	1
  poke_flash fl_first_free + 2,	2,	0
  poke_flash fl_first_free + 3,	0,	0
  poke_flash fl_first_free + 4,       fl_type_word, 0
  poke_flash fl_first_free + 5,	w,	0
  poke_flash fl_first_free + 6,	w,	1
  fl_first_free = fl_first_free + fl_ctrl_len + 2

  if fl_type <> fl_type_unknown then		' Variable war vorhanden
    poke_flash adr - 5, 0, 0			' deaktivieren alter Eintrag...
    poke_flash adr - 4, 0, 0			' Index auf 0
  endif

end ' of fl_sav_word

' ##############################################################
' fl_sav_long(idx, l)
' Schreiben eines longs in den Flash-Speicher

sub fl_sav_long(word idx; long l)

  word laenge
  long adr
  byte fl_type

  if (fl_first_free - block_base) > fl_datalength then	' Prfe Speicher voll
    fl_reorg = 1			' Reorg vormerken
  endif

  if (fl_first_free - block_base) > fl_maximum_usage then	' Speicher voll !
    return
  endif

  ' Variable suchen...
  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  fl_adresses(idx) = fl_first_free

  poke_flash fl_first_free, 		idx, 	0
  poke_flash fl_first_free + 1,	idx,	1
  poke_flash fl_first_free + 2,	4,	0
  poke_flash fl_first_free + 3,	0,	0
  poke_flash fl_first_free + 4,       fl_type_long, 0
  poke_flash fl_first_free + 5,	l,	0
  poke_flash fl_first_free + 6,	l,	1
  poke_flash fl_first_free + 7,	l,	2
  poke_flash fl_first_free + 8,	l,	3
  fl_first_free = fl_first_free + fl_ctrl_len + 4

  if fl_type <> fl_type_unknown then		' Variable war vorhanden
    poke_flash adr - 5, 0, 0			' deaktivieren alter Eintrag...
    poke_flash adr - 4, 0, 0
  endif

end ' of fl_sav_long


' ##############################################################
' fl_sav_real(idx, r)
' Schreiben eines reals in den Flash-Speicher

sub fl_sav_real(word idx; real r)

  word laenge
  long adr
  byte i
  byte fl_type

  if (fl_first_free - block_base) > fl_datalength then	' Prfe Speicher voll
    fl_reorg = 1			' Reorg vormerken
  endif

  if (fl_first_free - block_base) > fl_maximum_usage then	' Speicher voll !
    return
  endif

  ' Variable suchen...
  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  fl_adresses(idx) = fl_first_free

  poke_flash fl_first_free, 		idx, 	0
  poke_flash fl_first_free + 1,	idx,	1
  poke_flash fl_first_free + 2,	8,	0
  poke_flash fl_first_free + 3,	0,	0
  poke_flash fl_first_free + 4,       fl_type_real, 0
  for i = 0 to 7
    poke_flash fl_first_free + i + fl_ctrl_len,	r,	i	' Real byte fr byte ablegen
  next
  fl_first_free = fl_first_free + fl_ctrl_len + 8

  if fl_type <> fl_type_unknown then		' Variable war vorhanden
    poke_flash adr - 5, 0, 0			' deaktivieren alter Eintrag...
    poke_flash adr - 4, 0, 0
  endif

end ' of fl_sav_real

' ##############################################################
' fl_sav_string(idx, s$)
' Schreiben eines Strings in den Flash-Speicher
' Achtung : String darf nicht grsser als verfgbarer Flash-Block sein, sonst absturz !

sub fl_sav_string(word idx; string s$)

  word laenge, l
  long adr, r
  byte i
  byte fl_type

  l = len(s$)			' So viele Bytes werden geschrieben als Daten...

  if (fl_first_free - block_base) > fl_datalength then	' Prfe Speicher voll
    fl_reorg = 1			' Reorg vormerken
  endif

  if (fl_first_free - block_base) > fl_maximum_usage then	' Speicher voll !
    return
  endif

  ' Variable suchen...
  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  fl_adresses(idx) = fl_first_free

  poke_flash fl_first_free, 		idx, 	0
  poke_flash fl_first_free + 1,	idx,	1
  poke_flash fl_first_free + 2,	l,	0
  poke_flash fl_first_free + 3,	l,	1
  poke_flash fl_first_free + 4,       fl_type_string, 0

  r = pokem_flash(fl_first_free + fl_ctrl_len, s$, 0, l, 2)	' Return Code ignorieren... Mode 2 = standard-write

  fl_first_free = fl_first_free + fl_ctrl_len + l		' Erste Freie Adresse fortschreiben

  if fl_type <> fl_type_unknown then		' Variable war vorhanden
    poke_flash adr - 5, 0, 0			' deaktivieren alter Eintrag...
    poke_flash adr - 4, 0, 0
  endif

end ' of fl_sav_string

' ##############################################################
' fl_delete(idx)
' Lschen einer Variablen. Wie fl_sav, jedoch nur deaktivieren des alten Eintrags
sub fl_delete(word idx)

  word laenge, l
  long adr, r
  byte i
  byte fl_type

  ' Variable suchen...
  call fl_find_adr_fast(idx, adr, laenge, fl_type)

  fl_adresses(idx) = 0				' Kennung "gelscht"

  if fl_type <> fl_type_unknown then		' Variable war vorhanden
    poke_flash adr - 5, 0, 0			' deaktivieren alter Eintrag...
    poke_flash adr - 4, 0, 0
  endif

end ' of sub fl_delete
' ##############################################################
' fl_do_reorg()
' Reorganisieren des Flash-Speichers, wird ausgefhrt, wenn Platz verbraucht ist
' Nur zu verwenden fr fl_block_1 und 2
' nderung V00.91:
'   Name der Routine gendert von fl_reorg auf fl_do_reorg
'   Reorganisation wird ausgefhrt, wenn Flag fl_reorg auf "1" liegt. Dieses Flag
'     wird bei den fl_sav-Routinen gesetzt, wenn Speicher voll.
'   Wichtig: fl_datalength darf nicht so gro sein, dass der Platz dahinter bis
'     zur 64k-Grenze nicht mehr ausreicht um alle Daten bis zum fl_do_reorg() aufzunehmen
' V00.92: Prfen der Grenzen der Var-ID's und ggf. Abbruch, wenn ausserhalb der Grenzen

sub fl_do_reorg()

'print #dbg_dev, "fl_do_REORG: ", fl_reorg

  if fl_reorg = 0 then
    return
  endif

  long adr1, adr2, adr1_start, adr2_start	' Adr2 = Adresse Zielbereich
  byte zelle, fl_type
  word idx, laenge, i

  if block_base = fl_block_1 then	' Zu reorganisierender Bereich ist Bereich 1
    adr1 = fl_block_1			' Beginn der originaldaten
    adr2 = fl_block_2			' Beginn des neuen Speicherplatzes
  else
    adr1 = fl_block_2
    adr2 = fl_block_1			' oder eben rumgedreht
  endif

  erase_flash adr2, fl_blocklength  	' Bereich 2 lschen

  adr1_start = adr1			' Sektoranfang merken
  adr1 = adr1 + 1			' Pointer auf Datenanfang
  adr2_start = adr2			' Wir merken uns den Sektoranfang (Zielsektor)
  adr2 = adr2 + 1			' Pointer auf Datenanfang stellen

'#####################
fl_reorg_find_loop:

  peek_flash adr1, idx, 2		' Index einlesen
  peek_flash adr1 + 2, laenge, 2	' Lnge einlesen
  peek_flash adr1 + 4, fl_type, 1	' Typ des Satzes einlesen

'____?_?? prfen auf sinnvolle idx-eintrge ????????????

  if idx = 0FFFFh then			' Ende der Liste, alle Daten wurden kopiert
    goto fl_reorg_done
  endif

' ?? Prfen, ob das Lngenbyte Sinn macht. ACHTUNG! Je nach verwendeter Stringlnge
' fhrt das zum Abbruch auch bei "erlaubten" werten
' if laenge < 1 or laenge > max_laenge then
'   goto fl_reorg_done
' endif

  if idx = 0 then			' Gelschter Datensatz, gehe zum nchsten...
    adr1 = adr1 + fl_ctrl_len + laenge	' Pointer weiterschalten
    goto fl_reorg_find_loop		' Weiter mit nchstem Datensatz
  endif

' V00.97
  if idx > fl_maxvar then		' Ausserhalb bereich...
    goto fl_reorg_done			' Hier sollte man mal noch ein Flag setzen, zwecks
    					' Auswertung. Schreiben in Log wre hier unsinn :-(
  endif

' *** Kopiere Variable... *** - Byte fr Byte

  for i = 0 to laenge + fl_ctrl_len - 1	' Schleife ber gesamten Datensatz
    peek_flash adr1 + i, zelle, 1	' Lese Datenwert
    poke_flash adr2 + i, zelle, 0	' Schreibe Datenwert...
  next

  ' V00.85: Adresse ablegen fr Variable
  fl_adresses(idx) = adr2

  if fl_debug = 1 then
    print #dbg_dev, "fl_reorg: idx="; idx, " adr="; adr2; " len="; laenge
  endif

  adr1 = adr1 + fl_ctrl_len + laenge	' Nchste Adresse...
  adr2 = adr2 + fl_ctrl_len + laenge

' ????????? hier kann man eine Prfung auf die maximale Adresse einbauen

  goto fl_reorg_find_loop		' Weiter mit nchstem Datensatz...

fl_reorg_done:				' Well jetzt kann noch der andere Flash-Bereich aktiv geschaltet
					' werden und der alte Bereich wird auf "0" gesetzt
  poke_flash adr2_start, 1, 0		' Neuer Bereich aktivieren
  poke_flash adr1_start, 0, 0		' Alten Bereich deaktivieren
  block_base = adr2_start		' Globale Variable setzen
  call fl_last(fl_first_free)		' Berechne erstes freies Datenbyte im Block

  fl_reorg = 0				' Flag noch lschen

end ' of fl_do_reorg


' ##############################################################
' fl_dump(long start, length; byte level)
' Dump des Flash-Speichers als Hex auf Debug Ausgabe

sub fl_dump(long start, length; byte level)

  long adr, hbyte, le
  byte c16, fl_inhalt
  string s$(8)
  string zeile$(80)

  le = length

  print #dbg_dev, level; " -> FL_DUMP "; start; " / "; le

  adr = start
fl_dump_loop:

  call hexa_str(adr, 8, s$)			' Wandle Adresse in Hex um, Ausgeben
  zeile$ = s$ + " "

  for c16 = 0 to 15				' Ab dort die ersten 16 Bytes als hex anzeigen
    peek_flash adr + c16, fl_inhalt, 1
    hbyte = fl_inhalt
    call hexa_str(hbyte, 2, s$)			' Byte als Hex-String umwandeln
    zeile$ = zeile$ + s$ + " "
    if c16 = 7 then
      zeile$ = zeile$ + "| "			' Trennspalte nach 8 Bytes
    endif
  next

  zeile$ = zeile$ + "  "

  for c16 = 0 to 15				' jetzt noch als ASCII-Darstellung anhngen
    peek_flash adr + c16, fl_inhalt, 1

    if fl_inhalt < 32 or fl_inhalt > 127 then
      zeile$ = zeile$ + "."
    else
      zeile$ = zeile$ + chr$(fl_inhalt)
    endif

    if c16 = 7 then
      zeile$ = zeile$ + " "			' Trennspalte nach 8 Bytes
    endif
  next

  print #dbg_dev, zeile$

  adr = adr + 16
  le = le - 16
  if le > 0 then				' Schleife, bis alle Bytes ausgegeben
    goto fl_dump_loop
  endif

  print #dbg_dev, " DUMP END"

end ' of fl_dump

' ##############################################################
' AB HIER:
' Schreiben / Lesen der sequentiellen Dateien.
' Die sequentiellen Dateien sind folgendermassen abgelegt:
' Sektorbeginn bei fl_s_block_1 (= 3.Flash-Sektor  64k)
' Wenn dieser Sektor voll, wird in fl_s_block_2 weitergemacht...
' Der letzte String in Sektor fl_s_block_1 wird nur als ganzes abgelegt. Sollte
' der letzte nicht mehr in den Sektor passen, wird in fl_s_block_2 weitergemacht. Als
' Kennung wird dann hinter diesen letzten Satz die Handle-Nr. 0aaH abgelegt.

' ##############################################################
' Im ersten Byte eines Sektors (Byte 0) "01h" bedeutet "Gltiger Sektor"
' Andere Werte werden beim Init als ungltig behandelt, der Sektor ggfs. formatiert
'
' Struktur:
'  - jede "Datei" kann nur mit Strings geschrieben/gelesen werden
'  - eine entsprechende Typ-Konversion hat der Programmierer durchzufhren
'  - Datensatzstruktur:
'	- Byte 1: 	Handle-Nr. Sonderwert fl_s_next_block(0aaH)
'			-> Es geht im 2. Sektor weiter !
' 	- Word (2/3):	Lnge des Datensatzes, kann 0 sein. String ist dann ""
'	- Byte 4-n:	Datensatz.
'  - Wenn die Handle-Nr. 0 ist, ist der Datensatz gelscht gekennzeichnet
'

' Die jeweils bentigten File-ID's (BYTE) mssen eindeutig sein.
' Beim ffnen einer Datei zum Schreiben mit fl_s_open_write
' wird die alte Datei sofort ungltig gemacht und gelscht

' ##############################################################
' Variablen

array fl_s_start_adr(fl_s_max_handle) of long	' Je eine Start-Adresse pro Handle
		' speichert die erste Adresse einer datei dauerhaft ab fr
		' schnelleres auffinden des ersten Datensatzes beim ffnen...

array fl_s_address(fl_s_max_handle) of long	' Je eine Adresse pro Handle, gltig
		' wenn fl_s_status <> 0, enthlt aktuellen Pointer auf
		' nchsten Datensatz... Beim Schreiben ist jedesmal zu prfen,
		' ob pointer noch auf leerem Datensatz steht, ggfs. weiterschalten

#define fl_ss_closed	0		' Statusbyte "Datei geschlossen"
#define	fl_ss_read	1		' Statusbyte "Datei zum lesen geffnet"
#define	fl_ss_write	2		' Statusbyte "Datei zum schreiben geffnet"
#define	fl_ss_eof	3		' Statusbyte "Datei @ eof"
#define	fl_ss_append	4		' Statusbyte "Datei zum Anhngen geffnet"

array fl_s_status(fl_s_max_handle) of byte		' Status: s.o.

long  fl_s_first_free		' erste freie Adresse (hinter allen Dateien)

' ##############################################################
' fl_s_open_read(byte fileid)
' ffnen der Flash-Datei zum lesen

sub fl_s_open_read(byte fileid)

  if fileid = 0 or fileid > fl_s_max_handle then	' ungltig !
    return
  endif

  if fl_s_start_adr(fileid) = 0 then			' Adresse n/a -> EOF
    fl_s_status(fileid) = fl_ss_eof
    fl_s_address(fileid) = fl_s_first_free
  else
    fl_s_status(fileid) = fl_ss_read			' Adresse ok -> Ready to read
    fl_s_address(fileid) = fl_s_start_adr(fileid)	' Adresse eintragen fr 1. zugriff
  endif

end 'of fl_s_open_read

' ##############################################################
' fl_s_open_write(byte fileid)
' ffnen der Flash-Datei zum Schreiben !!!

sub fl_s_open_write(byte fileid)

  long adr
  byte status
  word laenge

  if fileid = 0 or fileid > fl_s_max_handle then	' ungltig !
    return
  endif

  if fl_s_start_adr(fileid) = 0 then			' Datei existiert nicht
    fl_s_address(fileid) = fl_s_first_free		' Startadresse am Ende des Blocks
    fl_s_start_adr(fileid) = fl_s_first_free		' Startadresse Datei auch eintragen
    fl_s_status(fileid) = fl_ss_write			' Status="Datei geffnet"
    return
  endif

  adr = fl_s_start_adr(fileid)				' Wir beginnen immer an Anfang

' zunchst alle Eintrge lschen...

fl_s_open_write_del_loop:
    call fl_s_search_next_old(fileid, adr, status)	' Versuche Eintrag zu finden

    if status = fl_s_s_ok then				' Nchster Eintrag gefunden
      poke_flash adr, 0, 0				' Index lschen, Eintrag ungltig setzen
      peek_flash adr + 1, laenge, 2			' Lnge des Eintrags lesen
      adr = adr + laenge + 3				' weiterschalten auf nchsten Eintrag...
      goto fl_s_open_write_del_loop			' nchster Eintrag bereit machen
    else
      if status = fl_s_s_notfound then	' bedeutet "keinen Eintrag gefunden". Wir haben jetzt das Ende der
  					' Datei gefunden... adr ist schon auf dem ersten freien Byte im
                                        ' Flash positioniert... (fl_s_first_free)
        fl_s_address(fileid) = adr	' aktuelle Daten-Adresse eintragen
        fl_s_start_adr(fileid) = adr	' Startadresse auch merken

        fl_s_status(fileid) = fl_ss_write ' Status="Datei geffnet"
      endif
    endif

end 'of fl_s_open_write

' ##############################################################
' fl_s_open_append(byte fileid)
' ffnen der Flash-Datei zum Schreiben !!! File-Pointer auf das Ende der Datei setzen

sub fl_s_open_append(byte fileid)

  long adr
  byte status
  word laenge

  if fileid = 0 or fileid > fl_s_max_handle then	' ungltig !
    return
  endif

  if fl_s_start_adr(fileid) = 0 then			' Datei existiert nicht
    fl_s_address(fileid) = fl_s_first_free		' Startadresse am Ende des Blocks
    fl_s_start_adr(fileid) = fl_s_first_free		' Startadresse Datei auch eintragen
    fl_s_status(fileid) = fl_ss_write			' Status="Datei geffnet"
    return
  endif

  fl_s_status(fileid) = fl_ss_append	' Status="Datei geffnet" zum Anhngen
  fl_s_address(fileid) = fl_s_first_free		'Arbeitsadresse = Erste freie Adresse
							' Startadresse nicht verndern !

end 'of fl_s_open_append

' ##############################################################
' 	- fl_s_close: zum schliessen: close der Datei, beendet file-operation, macht Datei gltig
sub fl_s_close(byte fileid)

  fl_s_status(fileid) = fl_ss_closed	' mehr ist erst mal nicht erforderlich
end ' of fl_s_close

' ##############################################################
' sub fl_s_write: Datenstze scheiben.
' Die Routine sucht erst mal die nchste freie Adresse und schreibt dann die Daten dort hin
' Retcode 0 = ok
' Retcode 1 = not open for write
' Retcode 2 = Speicher Voll. Daten nicht geschrieben !

sub fl_s_write(byte fileid; string s$; var byte retcode)

  long adr, r
  word laenge, i
  byte fl_id

  if fl_s_status(fileid) <> fl_ss_write then	' Status ist nicht ok -> exit mit fehler !
    retcode = 1
    return
  endif

  if fileid = 0 or fileid > fl_s_max_handle then	' ungltig !
    retcode = 3
    return
  endif

  adr = fl_s_address(fileid)			' Startadresse laden

fl_s_write_searchloop:

  peek_flash adr, fl_id, 1			' Lese erstes Statusbyte.
  if fl_id = 0ffh then				' ist leer -> wir knnen jetzt schreiben
    goto fl_s_write_write
  endif

  if fl_id = fl_s_next_block then		' Springe zum Block 2...
    adr = fl_s_block_2 + 1
    goto fl_s_write_searchloop
  endif

  peek_flash adr + 1, laenge, 2			' Lese Lngenwort
  adr = adr + laenge + 3			' Adresse weiterschalten
  goto fl_s_write_searchloop			' nchsten Datensatz prfen

fl_s_write_write:

  laenge = len(s$)				' Lnge merken

  ' prfen, ob noch platz im Block 1, ansonsten block 2 nutzen

  if adr < fl_s_block_2 then			' Wir sind in Block 1, Prfe ob Platz frei !
    if (adr + laenge + 5) > fl_s_block_2 then	' Nein ! Kein Platz mehr !
      poke_flash adr, fl_s_next_block, 0	' Kennung fr Next-Block
      poke_flash fl_s_block_2, 1, 0		' Kennung Block Aktiv (zur Sicherheit)
      adr = fl_s_block_2 + 1			' Adresse am Anfang...
      goto fl_s_write_searchloop		' Vorne anfangen, zur Sicherheit nochmal prfen
    endif
      		' (Beim nchsten Lauf wird dieses IF nicht mehr durchlaufen)
  endif

  if adr + laenge + 5 > fl_s_block_2 + fl_blocklength then	' HILFE ! MEMORY OVERRUN !
    retcode = 2
    return
  endif

  poke_flash adr, fileid, 0			' Schreibe file-ID
  poke_flash adr + 1, laenge, 0
  poke_flash adr + 2, laenge, 1			' Schreibe Lngenfeld

  adr = adr + 3

  if laenge > 0 then
    r = pokem_flash(adr, s$, 0, laenge, 2)	' Return Code ignorieren... Mode 2 = standard-write
  endif

  adr = adr + laenge
  fl_s_address(fileid) = adr			' Stelle pointer auf nchsten freien Eintrag...

  if adr > fl_s_first_free then
    fl_s_first_free = adr			' First free weiterschalten
  endif

  retcode = 0

end ' of fl_s_write

' ##############################################################
' sub fl_s_write_append: Datenstze schreiben, Anhngen !
' Die Routine sucht erst mal die nchste freie Adresse und schreibt dann die Daten dort hin
' Die Datenstze werden an die Datei hinten angehngt. Datei muss mit fl_s_open_append geffnet sein
' Retcode 0 = ok
' Retcode 1 = not open for append
' Retcode 2 = Speicher Voll. Daten nicht geschrieben !
' Retcode 3 = Handle Falsch

sub fl_s_write_append(byte fileid; string s$; var byte retcode)

  long adr, r
  word laenge, i
  byte fl_id

  if fl_s_status(fileid) <> fl_ss_append then	' Status ist nicht ok -> exit mit fehler !
    retcode = 1
    return
  endif

  if fileid = 0 or fileid > fl_s_max_handle then	' ungltig !
    retcode = 3
    return
  endif

  adr = fl_s_address(fileid)			' Startadresse laden

fl_s_write_append_searchloop:

  peek_flash adr, fl_id, 1			' Lese erstes Statusbyte.
  if fl_id = 0ffh then				' ist leer -> wir knnen jetzt schreiben
    goto fl_s_write_append_write
  endif

  if fl_id = fl_s_next_block then		' Springe zum Block 2...
    adr = fl_s_block_2 + 1
    goto fl_s_write_append_searchloop
  endif

  peek_flash adr + 1, laenge, 2			' Lese Lngenwort
  adr = adr + laenge + 3			' Adresse weiterschalten
  goto fl_s_write_append_searchloop		' nchsten Datensatz prfen

fl_s_write_append_write:

  laenge = len(s$)				' Lnge merken

  ' prfen, ob noch platz im Block 1, ansonsten block 2 nutzen

  if adr < fl_s_block_2 then			' Wir sind in Block 1, Prfe ob Platz frei !
    if (adr + laenge + 5) > fl_s_block_2 then	' Nein ! Kein Platz mehr !
      poke_flash adr, fl_s_next_block, 0	' Kennung fr Next-Block
      poke_flash fl_s_block_2, 1, 0		' Kennung Block Aktiv (zur Sicherheit)
      adr = fl_s_block_2 + 1			' Adresse am Anfang...
      goto fl_s_write_append_searchloop		' Vorne anfangen, zur Sicherheit nochmal prfen
    endif
      		' (Beim nchsten Lauf wird dieses IF nicht mehr durchlaufen)
  endif

  if adr + laenge + 5 > fl_s_block_2 + fl_blocklength then	' HILFE ! MEMORY OVERRUN !
    retcode = 2
    return
  endif

  poke_flash adr, fileid, 0			' Schreibe file-ID
  poke_flash adr + 1, laenge, 0
  poke_flash adr + 2, laenge, 1			' Schreibe Lngenfeld

  adr = adr + 3

  if laenge > 0 then				' Abfrage auf "0" zur Sicherheit...
    r = pokem_flash(adr, s$, 0, laenge, 2)	' Return Code ignorieren... Mode 2 = standard-write
  endif

  adr = adr + laenge
  fl_s_address(fileid) = adr			' Stelle pointer auf nchsten freien Eintrag...

  if adr > fl_s_first_free then
    fl_s_first_free = adr			' First free weiterschalten
  endif

  retcode = 0

end ' of fl_s_write_append

' ##############################################################
'	- fl_s_read: Datenstze lesen. Lese jeweils nchsten Datensatz
'	Retcode 0 = ok, datensatz gelesen
'	Retcode 1 = EOF, Ende der daten, string ist leer, Dateistatus auf EOF gesetzt, weiteres lesen erzeugt
'	Retcode 2 = Error: Filestatus <> fl_s_read

sub fl_s_read(byte fileid; var string s$; var byte retcode)

  long adr
  word laenge, i
  byte fl_id, stat

  if fl_s_status(fileid) <> fl_ss_read then	' Status ist nicht ok -> exit mit fehler !
    retcode = 2
    s$ = ""
    return
  endif

  if fl_s_status(fileid) = fl_ss_eof then	' Status ist eof -> return mit eof !
    retcode = 1
    s$ = ""
    return
  endif

  if fileid = 0 or fileid > fl_s_max_handle then	' ungltig !
    retcode = 3
    return
  endif

  adr = fl_s_address(fileid)			' Startadresse laden

fl_s_read_searchloop:

  peek_flash adr, fl_id, 1			' Lese erstes Statusbyte.
  if fl_id = 0ffh then				' ist leer -> EOF
    retcode = 1
    fl_s_status(fileid) = fl_ss_eof		' Status aktualisieren
    s$ = ""
    return
  endif

  if fl_id = fl_s_next_block then
    adr = fl_s_block_2 + 1
    goto fl_s_read_searchloop
  endif

  peek_flash adr + 1, laenge, 2			' Lese Lngenwort

  if fl_id = fileid then			' gefunden, lese Daten
    peek_flash adr + 3, s$, laenge		' String einlesen
    adr = adr + 3 + laenge
    fl_s_address(fileid) = adr			' neuen Pointer setzen
    retcode = 0
    return
  endif
					' nicht gefunden -> weitersuchen
  adr = adr + 3 + laenge			' weiterschalten
  call fl_s_search_next_old(fileid, adr, stat)	' Nchste Adresse auffinden

  goto fl_s_read_searchloop	' entweder er findet "EOF" oder er findet neuen Datensatz...

end ' of fl_s_read

' ##############################################################
' fl_s_search_end(var long adr; var byte status)
' sucht erste freie Adresse im fl_s_-Bereich. Luft sequentiell. Nur fr fl_s_init geeignet
' returns    0 -> alles klar
'         <> 0 -> Fehler

sub fl_s_search_end(var long adr; var byte status)

  byte flash_id
  word laenge

  adr = fl_s_block_1 + 1

fl_s_search_end_loop:

  peek_flash adr, flash_id, 1		' Lese ID-Byte ein

  if flash_id = 0ffH then		' Ende des flashs, keine Daten, Adr steht auf 1. freiem Byte im Flash

'print #dbg_dev, "fl_s_search_end returns "; adr

    status = 0
    return
  endif

  if flash_id = fl_s_next_block then
    adr = fl_s_block_2 + 1
    goto fl_s_search_end_loop
  endif

  peek_flash adr + 1, laenge, 2		' Lnge lesen (des Eintrags, dessen id-Byte nicht zu uns gehrt)

  adr = adr + laenge + 3		' Weiterschalten auf nchsten Eintrag...

  if adr > fl_s_block_2 + fl_blocklength then		' Fehler -> Overflow
    status = 1

    if fl_debug = 1 then
      print #dbg_dev, "*** fl_s_search_end returns 1 -> "; adr
    endif

    return
  endif

  goto fl_s_search_end_loop			' weitermachen, bis gefunden...

end ' of sub fl_s_search_end

' ##############################################################
' fl_s_search_next_old(byte fileid; var long adr; var byte status)
' Suche nchstes Vorkommen eines Datensatzes mit der angegebenen File-ID
' Beim eintritt muss (!!!!) adr auf dem ID-Byte stehen.
' Bei Return steht "adr" immer auf dem ersten Byte des Datensatzes (ID-Byte)
' Sollte nichts gefunden woren sein, so steht "adr" auf dem
' ersten freien Platz im Flash "ready for poke"
' Status: returncode -> Siehe defines !

sub fl_s_search_next_old(byte fileid; var long adr; var byte status)

  byte flash_id
  word laenge
'########################???????????#####stack check debug start#######
' call check_stack(4)
'########################???????????#####stack check debug end#######

fl_s_search_loop:

  peek_flash adr, flash_id, 1		' Lese ID-Byte ein

  if flash_id = 0ffH then		' Ende des flashs, keine Daten, Adr steht auf 1. freiem Byte im Flash
    status = fl_s_s_notfound
    return
  endif

  if flash_id = fl_s_next_block then
    adr = fl_s_block_2 + 1
    goto fl_s_search_loop
  endif

  if flash_id = fileid then		' eintrag gefunden...
    status = fl_s_s_ok			' Status aktualisieren
    return
  endif

  peek_flash adr + 1, laenge, 2		' Lnge lesen (des Eintrags, dessen id-Byte nicht zu uns gehrt)

  adr = adr + laenge + 3		' Weiterschalten auf nchsten Eintrag...
  goto fl_s_search_loop			' weitermachen, bis gefunden...

end ' of fl_s_search_next_old

' ##############################################################
' fl_s_copyfile(Byte fromfile, tofile; Var Byte copyfile_retcode)
' kopiert eine Datei in eine andere Datei
'	es werden die standard-Flash-S-Funktionen verwendet.
' 	Die Zieldatei wird gnadenlos gelscht !
'  RETURNS
'	copyfile_retcode:
'	0 = OK, copyfile_recs enthlt die kopierte Satzanzahl
'	1 = ERROR beim ffnen der Eingabedatei
'	2 = ERROR beim Lesen der Eingabedatei
'	3 = Error beim ffnen der Ausgabedatei
'	4 = Error beim Schreiben der ausgabedatei
'	5 = Allgemeiner Fehler

sub fl_s_copyfile(Byte Fromfile, Tofile; Var Byte copyfile_retcode; Var Long copyfile_recs)

  string zeile$(fl_s_maxstring)			' Hier werden die Zeilen umkopiert...
  Byte rc, r

  copyfile_retcode = 5					' Standard-Return

  copyfile_recs = 0

  call fl_s_open_write(tofile)			' Datei zur Ablage ffnen

  if fl_s_status(tofile) <> fl_ss_write	then	' Status="Datei geffnet" is nicht ok !
    copyfile_retcode = 3
    return
  endif

  call fl_s_open_read(fromfile)			' Versuche Eingabedatei zu ffnen
  if fl_s_status(fromfile) = fl_ss_eof then	' Keine Daten in Eingabedatei -> just exit !
    copyfile_retcode = 0
    call fl_s_close(tofile)			' Ausgabedatei noch schlieen
    call fl_s_close(fromfile)			' eingabedatei noch schlieen
    return
  endif

  if fl_s_status(fromfile) <> fl_ss_read then	' Status ist nicht ok...
    copyfile_retcode = 1
    call fl_s_close(tofile)			' Ausgabedatei noch schlieen
    call fl_s_close(fromfile)			' eingabedatei noch schlieen
    return
  endif

  call fl_s_read(Fromfile, zeile$, rc)			' Erste Zeile lesen.

  while rc = 0						' Lesen, bis RC Fehler / EOF enthlt

    call fl_s_write(Tofile, zeile$, r)		' Zeile schreiben

    if r <> 0 then
      copyfile_retcode = 4
      call fl_s_close(tofile)			' Ausgabedatei noch schlieen
      call fl_s_close(fromfile)			' eingabedatei noch schlieen
      return
    endif

    copyfile_recs = copyfile_recs + 1		' Satzanzahl hochzhlen

    call fl_s_read(Fromfile, zeile$, rc)  	' Weiter Zeilen lesen.
  endwhile

  call fl_s_close(Tofile)			' Dateien schliessen
  call fl_s_close(Fromfile)			' Dateien schliessen

  copyfile_retcode = 0

end ' of sub fl_s_copyfile

' ##############################################################
' fl_s_init()
' initialisieren der Flash-Verarbeitung "Sequential"

sub fl_s_init()

  byte i, wert1, wert2
  byte flash_id
  long s_adr
  word laenge
  string w1$(8), w2$(8)

  if fl_debug = 1 then
    print #dbg_dev, "fl_s_init: ", ticks()
  endif

  peek_flash fl_s_block_1, wert1, 1	' Block Status lesen

  if wert1 <> 1 then			' Block ungltig !

    erase_flash fl_s_block_1, fl_blocklength	' ersten Flash_s-Sektor lschen
    erase_flash fl_s_block_2, fl_blocklength	' zweiten Flash_s-Sektor lschen
    poke_flash fl_s_block_1, 1, 0		' Definierte Anfangszustand, alle Dateien gelscht
    poke_flash fl_s_block_2, 1, 0		' Definierte Anfangszustand, alle Dateien gelscht
  endif

  ' Jetzt: Datei-Handles initialisieren

  call fl_s_init_handles()

  ' In einer Schleife werden jetzt die Startadressen ermittelt

  s_adr = fl_s_block_1 + 1

  fl_s_init_loop:
    peek_flash s_adr, flash_id, 1

    if flash_id = 0ffH then			' ende der Liste, ende des Init
      fl_s_first_free = s_adr
      goto fl_s_init_done
    endif

    if flash_id = fl_s_next_block then		' im 2. Block weiter !
      s_adr = fl_s_block_2 + 1
      goto fl_s_init_loop
    endif

    if flash_id > 0 then			' eintrag gltig
      if fl_s_start_adr(flash_id) = 0 then	' noch nicht initialisiert
        fl_s_start_adr(flash_id) = s_adr	' Adresse eintragen
        fl_s_address(flash_id) = s_adr		' Adresse eintragen

        if fl_debug = 1 then
          print #dbg_dev, "fl_s_init: Datei "; flash_id; " adr="; s_adr
        endif
      endif
    endif

    peek_flash s_adr + 1, laenge, 2		' Lnge lesen
    s_adr = s_adr + laenge + 3			' Weiterschalten auf nchsten Eintrag...

    goto fl_s_init_loop

  fl_s_init_done:

  ' fl_s_first_free ist hier gesetzt...

  if fl_debug = 1 then
    print #dbg_dev, ticks(), "fl_s_first_free: "; fl_s_first_free
  endif

end ' of fl_s_init()

' ##############################################################
'sub fl_s_init_handles()
' Initalisieren der mglichen Handles. Wird aus fl_s_init und fl_s_reorg aufgerufen

sub fl_s_init_handles()
  byte i

  for i = 0 to fl_s_max_handle - 1		' Initialisiere alle globalen Var's
    fl_s_address(i)   = 0			' Adresse auf 0 bedeutet: nicht vorhanden !
    fl_s_start_adr(i) = 0			' Adresse auf 0 bedeutet: nicht vorhanden !
    fl_s_status(i)    = fl_ss_closed		' Status: 0=Closed
  next
end

' ##############################################################
' fl_s_reorg()
'	- fl_s_reorg: Prfen der im Speicher befindlichen Datenstze
'	- ggfs. Reorganisation des Speichers
'	- Luft nur, wenn *ALLE* Dateien geschlossen sind !!!! (wird geprft !)
'	- Wenn nicht alle Dateien geschlossen sind, macht die Routine gar nichts !
'	- ACHTUNG: Daten werden blockweise im nicht genutzten Teil des
'		   Variablen-Flash (fl_block_1 oder 2) abgelegt.
'	 	   Ein etwaiger Stromausfall whrend REORG ist kein kompletter Daten
'		verlust, sondern kann ggfs. restauriert werden
'
' Ablauf:
'  - Kopieren Flash-block (1 dann 2) in den fl_block_1 oder 2 (je nachdem, welcher frei)
'  - lschen des Flash-Blocks
'  - Zurckschreiben der gltigen Eintrge in den FLASH, dabei reorganisieren
'  - Dabei: Bercksichtigen der grenze zum 2. Flash-Block

sub fl_s_reorg()
  byte ok, b
  string w1$(5)
  long adr, adr2
  byte zelle
  long laenge, i
  byte idx
  long r, adress, z, adr_current
  long fl_s_reorg_block, res
  string temp_s$(fl_s_maxstring3)

'########################???????????#####stack check debug start#######
 'call check_stack(13)
'########################???????????#####stack check debug end#######

  if fl_debug = 1 then
    print #dbg_dev, "fl_s_reorg: ", ticks()
  endif

  ok = 1

  for i = 0 to fl_s_max_handle - 1		' Check-Schleife
    if fl_s_status(i) <> fl_ss_closed then
      ok = 0
      w1$ = str$(i)
    endif
  next

  if ok = 0 then				' Irgend eine datei ist noch offen - Exit
    return
  endif

  if fl_s_first_free < fl_s_block_2 then		' noch nicht in Block 2 -> ich habe fertig !
    return
  endif

  if (fl_s_first_free - fl_s_block_2) < fl_s_datalength then	' Flash noch nicht voll - exit !
    return
  endif

  ' flash hat mindestens eine Fllung von fl_s_datalength -> es soll reorganisiert werden !

  if block_base = fl_block_1 then	' Zu reorganisierender Bereich ist Bereich 1
    fl_s_reorg_block = fl_block_2	' Nutze Block_2, da momentan ungenutzt
  else
    fl_s_reorg_block = fl_block_1	' oder eben rumgedreht
  endif

  call fl_s_init_handles() 		' Datei-Handles initialisieren

'wait_duration 5000

  erase_flash fl_s_reorg_block, fl_blocklength		' Lsche den Reorg-Speicher

'print #dbg_dev, "fl_s_reorg_block set to: ", fl_s_reorg_block
'print #dbg_dev, "fl_s_reorg copy 1 : ", ticks()

  ' 2.: Kopiere 1. Block in den Zwischenspeicher, wir kopieren komplett, ohne prfung

  adr = fl_s_block_1		' Von hier
  adr2 = fl_s_reorg_block	' nach hier wird kopiert

  set_len$(temp_s$, 256)

  fl_s_reorg_repeat:
    peek_flash adr, temp_s$, 256		' 256 Bytes lesen
    res = pokem_flash(adr2, temp_s$, 0, 256, 2)

    adr = adr + 256
    adr2 = adr2 + 256

    if (adr2 - fl_s_reorg_block) < fl_blocklength then
      goto fl_s_reorg_repeat
    endif
          ' lschen des 1. Reorg-Blocks
  erase_flash fl_s_block_1, fl_blocklength  	' Bereich 1 lschen

'print #dbg_dev, "fl_s_reorg copy 1 ok: ", ticks()

'##################### Schleife ber alle Eintrge im Speicher... ##########

  adr2 = fl_s_reorg_block + 1		' von hier wird geladen (Byte 0 wird ignoriert)
  adr = fl_s_block_1 + 1		' hier wird hingeschrieben

fl_s_reorg_find_loop:

  peek_flash adr2, idx, 1		' Index lesen
  peek_flash adr2 + 1, laenge, 2        ' Lnge lesen

  if idx = 0FFh then			' Ende der Liste, alle Daten wurden kopiert
    goto fl_s_reorg_done		' Das kann eigentlich nicht sein, da in Block 2 Daten vorhanden !
  endif

  if idx = fl_s_next_block then
    adr_current = adr			' Aktuelle Zieladresse merken !
    goto fl_s_reorg_block2		' Nchsten Block verarbeiten
  endif

  if idx = 0 then			' Gelschter Datensatz, gehe zum nchsten...
    adr2 = adr2 + 3 + laenge
    goto fl_s_reorg_find_loop		' Weiter mit nchstem Datensatz
  endif

' V00.97
  if idx > fl_s_max_handle then		' Ungltige Daten !
    goto fl_s_reorg_done		' Abbrechen. ????? evtl. noch Protokollieren !
  endif

  if fl_s_start_adr(idx) = 0 then	' noch nicht initialisiert
    fl_s_start_adr(idx) = adr		' Adresse eintragen
    fl_s_address(idx) = adr 		' Adresse eintragen

  if fl_debug  = 1 then
    print #dbg_dev, "fl_s_reorg: 1 Datei "; idx; " adr="; adr
  endif

  endif

  ' Kopiere Datensatz in den Flash zurck...(samt File-ID-Index und Lnge)

  peek_flash adr2, temp_s$, laenge + 3
  res = pokem_flash(adr, temp_s$, 0, laenge + 3, 2)

  adr  =  adr + 3 + laenge
  adr2 = adr2 + 3 + laenge

' ????????? hier kann man eine Prfung auf die maximale Adresse einbauen


  goto fl_s_reorg_find_loop		' Weiter mit nchstem Datensatz...

' ################### Block 2 ####################
' wird durchgefhrt wie block 1

fl_s_reorg_block2:			' fr den 2. Block fl_s_...

  erase_flash fl_s_reorg_block, fl_blocklength		' Lsche den Reorg-Speicher

'print #dbg_dev, "fl_s_reorg copy 2: ", ticks()

  ' Kopiere 2. Block in den Zwischenspeicher, wir kopieren komplett, ohne prfung

  adr = fl_s_block_2		' Von hier
  adr2 = fl_s_reorg_block	' nach hier wird kopiert

  set_len$(temp_s$, 256)

  fl_s_reorg_repeat_2:				' Schleife: Kopieren gesamter Block in reorg-Block
    peek_flash adr, temp_s$, 256		' 256 Bytes lesen
    res = pokem_flash(adr2, temp_s$, 0, 256, 2)

    adr = adr + 256
    adr2 = adr2 + 256

    if (adr2 - fl_s_reorg_block) < fl_blocklength then
      goto fl_s_reorg_repeat_2
    endif

  erase_flash fl_s_block_2, fl_blocklength  	' Bereich 2 lschen

'print #dbg_dev, "fl_s_reorg copy 2 ok: ", ticks()

  adr2 = fl_s_reorg_block + 1		' von hier wird geladen (Byte 0=Blockstatus ignoriert)
  adr = adr_current			' hier wird hingeschrieben (oben gemerkt)

fl_s_reorg_find_loop2:

  peek_flash adr2, idx, 1		' Index lesen
  peek_flash adr2 + 1, laenge, 2        ' Lnge lesen

  if idx = 0FFh then			' Ende der Liste, alle Daten wurden kopiert
    goto fl_s_reorg_done
  endif

  if idx = 0 then			' Gelschter Datensatz, gehe zum nchsten...
    adr2 = adr2 + 3 + laenge
    goto fl_s_reorg_find_loop2		' Weiter mit nchstem Datensatz
  endif

' V00.97
  if idx > fl_s_max_handle then		' Ungltige Daten !
    goto fl_s_reorg_done		' Abbrechen. ????? evtl. noch Protokollieren !
  endif

  ' Kopiere Datensatz in den Flash zurck...(samt File-ID-Index und Lnge)

  peek_flash adr2, temp_s$, laenge + 3

  ' prfen, ob noch platz im Block 1, ansonsten block 2 nutzen

  if adr < fl_s_block_2 then			' Wir sind in Block 1, Prfe ob Platz frei !
    if (adr + laenge + 5) > fl_s_block_2 then	' Nein ! Kein Platz mehr !
      poke_flash adr, fl_s_next_block, 0	' Kennung fr Block 2
      adr = fl_s_block_2 + 1			' neue Adresse: Block 2

'print #dbg_dev, "switching to block 2 in File "; idx; " ("; temp_s$; ")"

    endif
  endif

  if fl_s_start_adr(idx) = 0 then	' noch nicht initialisiert
    fl_s_start_adr(idx) = adr		' Adresse eintragen
    fl_s_address(idx) = adr 		' Adresse eintragen

  if fl_debug  = 1 then
    print #dbg_dev, "fl_s_reorg: 2 Datei "; idx; " adr="; adr
  endif

  endif

  res = pokem_flash(adr, temp_s$, 0, laenge + 3, 2)

  adr  =  adr + 3 + laenge
  adr2 = adr2 + 3 + laenge

' ????????? hier kann man eine Prfung auf die maximale Adresse einbauen

  goto fl_s_reorg_find_loop2		' Weiter mit nchstem Datensatz...

' ######################## Reorganisation erledigt, beide Blcke neu geschrieben ###############

fl_s_reorg_done:

  poke_flash fl_s_block_1, 1, 0			' Blcke markieren, fertig...
  poke_flash fl_s_block_2, 1, 0

  fl_s_first_free = adr				' Erste Freie Adresse merken

  if fl_debug = 1 then
    print #dbg_dev, "fl_s_reorg ok: ", ticks(), " fl_s_first_free = ", fl_s_first_free
  endif

end ' of sub fl_s_reorg()

' ##############################################################
' fl_status(var Long var_used; var long var_effective; var long s_used; var long s_effective)
'
' Ermitteln des verbrauchten Flash-Speichers
'
' Return:
' var_used:		Anzahl der belegten Bytes im Variablen-flash
' var_effective:        Anzahl der davon genutzten Bytes (ohne "Lcher")
' s_used:		Anzahl der belegten Bytes im Flash-S-Speicher (Seq.-Dateien)
' s_effective:		Anzahl der davon genutzten Bytes (ohne "Lcher")

sub fl_status(var Long var_used; var long var_effective; var long s_used; var long s_effective)

  long adr, fl1_base, fls_offset
  word f_idx, f_laenge
  byte f_type

  long effective
  byte b, fs_idx

'########################???????????#####stack check debug start#######
'call check_stack(12)
'########################???????????#####stack check debug end#######

  ' 1.:Ermitteln der Adresse, des 1. freien Bytes im Var-Flash. Dabei mitprotokollieren,
  '    wie viele Bytes genutzt sind

  peek_flash fl_block_1, b, 1
  if b <> 1 then
    peek_flash fl_block_2, b, 1
    if b <> 1 then			' FEHLER !
      var_used = 0
      var_effective = 0
      s_used = 0
      s_effective = 0
      return
    endif
    fl1_base = fl_block_2 + 1
  else
    fl1_base = fl_block_1 + 1
  endif

  ' 2.: Schleife ber alle Eintrge, ermitteln letzte adresse und verwendeter Speicherplatz

  adr = fl1_base
  effective = 0

fl_status_loop1:

  peek_flash adr, f_idx, 2
  peek_flash adr + 2, f_laenge, 2

  if f_idx = 0ffffH then				' ende erreicht
    goto fl_status1
  endif

  if f_idx <> 0 then					' Eintrag mitzhlen... nur wenn nicht gelscht
    effective = effective + f_laenge + fl_ctrl_len	' Einschliessen Control-Info
  endif

  adr = adr + f_laenge + fl_ctrl_len			' weiterschalten
  goto fl_status_loop1

fl_status1:
  var_used      = adr - fl1_base
  var_effective = effective

  ' 3.: Das gleiche fr die Dateien (FL_s)

  adr = fl_s_block_1 + 1
  effective = 0
  fls_offset = 0

fl_status_loop2:

  peek_flash adr, fs_idx, 1		' Datei holen
  peek_flash adr + 1, f_laenge, 2	' Lnge holen

  if fs_idx = 0ffH then			' ende erreicht
    goto fl_status2
  endif

  if fs_idx = fl_s_next_block then
    fls_offset = fl_s_block_2 - adr	' Merken freier Platz im Block 1
    adr = fl_s_block_2 + 1
    goto fl_status_loop2		' Nchsten Block verarbeiten
  endif

  if fs_idx <> 0 then			' Nur wenn daten da mitzhlen !
    effective = effective + f_laenge + 3	' Einschliessen Control-Info
  endif

  adr = adr + f_laenge + 3		' weiterschalten
  goto fl_status_loop2

fl_status2:
  s_used      = adr - fl_s_block_1 - fls_offset
  s_effective = effective

  if fl_debug = 1 then
    print #dbg_dev, "fl_status: "; var_used; " / "; var_effective; &
		        " / "; s_used; " / "; s_effective
  endif

end ' of sub fl_Status

'###################################################

' hexa_str	Umwandeln eines Werts in einen Hex-String
' Variablen: 	wert:		Long Wert
'            	numchars: 	Anzahl der Stellen (2 oder 4 oder 8)
'		VAR hs$: 	Zurckgegebener String, max 8 Chars

sub hexa_str(long wert; byte numchars; var string hs$)

  if numchars = 2 then
    hs$ = 						&
      mid$(fl_hexstr$, (wert bitand 0F0h) shr 4, 1) +	&
      mid$(fl_hexstr$, (wert bitand 00Fh), 1)
  else
  if numchars = 4 then
    hs$ = 						&
      mid$(fl_hexstr$, (wert bitand 0F000h) shr 12, 1) +	&
      mid$(fl_hexstr$, (wert bitand 00F00h) shr 8, 1) +	&
      mid$(fl_hexstr$, (wert bitand 000F0h) shr 4, 1) +	&
      mid$(fl_hexstr$, (wert bitand 0000Fh), 1)
  else
  if numchars = 8 then
    hs$ = 							&
      mid$(fl_hexstr$, (wert bitand 0F0000000h) shr 28, 1) +	&
      mid$(fl_hexstr$, (wert bitand 00F000000h) shr 24, 1) +	&
      mid$(fl_hexstr$, (wert bitand 000F00000h) shr 20, 1) +	&
      mid$(fl_hexstr$, (wert bitand 0000F0000h) shr 16, 1) +	&
      mid$(fl_hexstr$, (wert bitand 00000F000h) shr 12, 1) +	&
      mid$(fl_hexstr$, (wert bitand 000000F00h) shr 8, 1) +	&
      mid$(fl_hexstr$, (wert bitand 0000000F0h) shr 4, 1) +	&
      mid$(fl_hexstr$, (wert bitand 00000000Fh), 1)
  endif
  endif
  endif

end


'*******************************************
' END OF FLASH.INC
' (c) copyright
' Martin Graeber
' Vogelweher Str. 32
' 67661 Kaiserslautern
' Tel. 0631 3506059
' mailto: mg@grco.de

