'
' Projekt:	HANS
' ##############################################################
'
' Modul:	LED.INC / Funktionen zum Ansteuern der Debug-LED
'
' ##############################################################
'
' funktionen:

' led_init()			' Initialisieren, Start der LED-Task
' led_speed(byte timer)		' Geschwindigkeit des LED-Blinken steuern
' led_toggle()			' LED umschalten, "flicker"-Effekt wird erzeugt
'

#define	led_port	008h	' Port der LED = 8
#define	led_mask	010h	' Anschluss = 084h
#define led_on		010h	' LED einschalten
#define led_off		000h	' LEd ausschalten
#define	led_bit		4	' welches bit ?

byte	led_counter		' Zhler fr LED-blinken
byte	led_counter_setup	' Setup-Wert fr Zhler
byte	led_current		' Aktuell ausgegebenes Byte an die LED

' ##############################################################
' led_init:	initialisieren des Modul LED
' 		Initialisieren Port, Timer, Start Task
'		Aufruf sollte nach den allgemeinen Gerte-inits kommen
' ##############################################################
sub led_init()

  led_current = 0			' LED aus, wird durch led_speed wieder eingeschaltet

  dir_pin led_port, led_bit, 0		' Port als Ausgang schalten

  call led_speed(10)			' 1 Sekunde blinking interval...

  if LED_ACTIVE = 1 then		' Nur wenn gewnscht... (Task Main define)
    RUN_TASK led_blinker, 1
  endif

END ' of led_init

' ##############################################################
' led_blinker:	Task fr das Blinken der LED
' ##############################################################
task led_blinker

led_loop:
  wait_duration 100			' Warte auf nchstes tick
  led_counter = led_counter - 1		' Zhle weiter
  if led_counter > 0 then
    goto led_loop
  endif					' Warte, bis Zhler abgelaufen

  call led_toggle()			' led_toggle schaltet um und setzt Zhler neu

goto led_loop				' Ohne ende...

end ' of task led_blinker

' ##############################################################
' led_toggle():	LED umschalten
' 		Counter wieder starten
' ##############################################################
sub led_toggle()

  if led_current = led_on then
    led_current = led_off
  else
    led_current = led_on
  endif

  out led_port, led_mask, led_current		' LED entsprechend ansteuern

  led_counter = led_counter_setup

end ' of led_toggle


' ##############################################################
' led_speed(word timer)		' Geschwindigkeit des LED-Blinken steuern
' ##############################################################
sub led_speed(byte counter_setup)

  led_counter = 1
  led_counter_setup = counter_setup

  call led_toggle()

end ' of sub(led_speed)

